// --- [ global.h ] ----------------------------------------------------------

#ifndef EXTERN
#define EXTERN extern
#endif

#define TRUE          			1
#define FALSE         			0

#define GET_ADR_LIST_FROM_EEPROM 	TRUE	// Die Adressen aus dem Eeprom lesen (->TRUE) oder aus main() (->FALSE)
#define DEVICES           		9				// Anzahl der Adressen fr XBees (incl. 2 fr Koordinator/Broadcast)

#define TEST_CONDITIONS			FALSE			// Bedingungen fr Sensoren / Aktoren auswerten

#define FRM_COMPLETE        	1
#define FRM_EXECUTE_CMD      	2
#define FRM_DISPLAY           3
#define FRM_LOG_DATA				4

#define LED_PORT					PORTD
#define LED_DDR					DDRD
#define LED_PIN					PIND
#define LED_1						PD4
#define LED_2						PD5

#define LED_1_ON					(LED_PORT |=  (1<<LED_1))
#define LED_1_OFF					(LED_PORT &= ~(1<<LED_1))
#define LED_1_TOG					(LED_PIN   =  (1<<LED_1))

#define LED_2_ON					(LED_PORT |=  (1<<LED_2))
#define LED_2_OFF					(LED_PORT &= ~(1<<LED_2))
#define LED_2_TOG					(LED_PIN   =  (1<<LED_2))

// Es wird der Timer2 benutzt
#define TIMER0_START				(0<<CS02 | 1<<CS01 | 1<<CS00)  // Prescale 64
#define TIMER0_STOP				0
#define TIMER0_PRELOAD			128

#define TIMER2_START				(1<<CS22 | 0<<CS21 | 0<<CS20)  // Prescale 64
#define TIMER2_STOP				0
#define TIMER2_PRELOAD			128

#define TWI_SLA_ADR				0x80			// eigene Adresse als TWI-Slave
#define TWI_TARGET_ADR			0x04			// an diese Adresse verschickt der TWI-Master die Daten
														// EEPROM Adressen
#define EEPROM_ADR_TWI 			0x04			// hier steht im Eeprom die TWI_Adresse
#define EEPROM_ADR_TARGET		0x0A			// ab hier stehen im EEprom die Targetadressen
#define EEPROM_ADR_CONTRAST	0x05			// die Adresse fr den LCD-Kontrast
#define EEPROM_ADR_LED			0x06			// die Adresse fr die Helligkeit der Hintergrundbeleuchtung

#define LOGGER_TWI_ADR        0x04			// ############## !!!

#define SEPARATOR					';'
#define SEPARATOR_STR			";"
#define DEZIMAL_TRENNZEICHEN 	','

EXTERN char cv[16];

EXTERN uint8_t xbee_cmd_typ;
EXTERN uint8_t xbee_target_idx;
EXTERN uint8_t xbee_data[16];
EXTERN uint8_t xbee_data_length;
EXTERN uint8_t xbee_flag;
EXTERN uint8_t xbee_devices;

EXTERN uint8_t xbee_target_adr[DEVICES][10];

// --- { eof ] ----------------------------------------------------------------
