// --- [ main.c ] ------------------------------------------------------------

/*
Dies ist der Programmcode fr einen Coordinator in einem Netz von standalone XBee's
Er protokolliert alle eingehenden Daten via TWI-Adr 4 (auf einen USB-Stick)

Das DCF77-Modul ist entfernt

*/

#define EXTERN
#include <avr/io.h>
#include <inttypes.h>
#include <stdlib.h>
#include <string.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

#include "global.h"
#include "xbee_api_c.h"
#include "rs232_int.h"
#include "TWI_Master_c.h"
#include "frames_c.h"

// hier knnen die Adressen von weiteren Stationen eingeben werden.
// die beiden ersten Eintrge fr Coordinator und Broadcast sollten
// unverndert bleiben.
// In der Zeile 3 wird die Seriennummer des Coordinators eingetragen
// ab Zeile 4 folgen die Router - hier sind 2 davon eingetragen
uint8_t xbee_target_adr[DEVICES][10] = {
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFE},
{0x00, 0x13, 0xA2, 0x00, 0x40, 0x33, 0x7B, 0xB7, 0xFF, 0xFE},
{0x00, 0x13, 0xA2, 0x00, 0x40, 0x70, 0xF4, 0x7F, 0xFF, 0xFE},
{0x00, 0x13, 0xA2, 0x00, 0x40, 0x6A, 0x4B, 0x3F, 0xFF, 0xFE}
};

// ----------------------------------------------------------------------------
int main(void)
{
	uint8_t frm;

	rs232_init();
	TWI_Master_Initialise();

// --- Timer0 ---------------------

// --- Timer1 --------------------- ist unbenutzt

// --- Timer2 --------------------- wird vom RS232-Modul genutzt und dort konfiguriert

														// Nicht benutzte Module abschalten
	PRR = (0<<PRTWI | 0<<PRTIM2 | 0<<PRTIM1 | 0<<PRTIM0 | 1<<PRSPI | 0<< PRUSART0 | 1<<PRADC);
	ACSR = 1<< ACD;								// Analog Comparator Disable

	LED_DDR  |= (1<<LED_1 | 1<<LED_2);

	asm volatile ("sei");

	xbee_data[0] = LOGGER_TWI_ADR;			// Eine Startmeldung am TWI-Display ausgeben
	xbee_data[1] = 0;
	strcat((char *) xbee_data, "XBee Start");
	
	TWI_MA_Start_Transceiver_With_Data(xbee_data, strlen((char *) xbee_data));

														// in einer Endlosschleife wird geprft, ob
														// ein Frame empfangen wurde
                                  			// wenn ja, dann wird der Frame-Code ermittelt
	while(1)                               // und abhngig vom Frame-Code weiter ausgewertet
		{

		if (FRM_is_received())        		// Testen, ob ein Frame empfangen wurde
			{
//			LED_2_TOG;								// LED_2 toggled, wenn ein Frame empfangen wurde
			frm = FRM_get_frame_typ();       // den Frametyp auslesen
			
			
// --- FRM 0x88 ---------------------------------------------------------------
			if (frm == 0x88)                 	// AT Command Response
				{
				}
// --- FRM 0x8A ---------------------------------------------------------------
			else if (frm == 0x8A)            	// Modem Status
				{
			//	FRM0x8A();
				}
// --- FRM 0x8B ---------------------------------------------------------------
			else if (frm == 0x8B)            	// Transmit Status
				{
				}

// --- FRM 0x90 ---------------------------------------------------------------
			else if (frm == 0x90)            	// Receive Packet
				{
			//	FRM0x90();
				}

// --- FRM 0x92 --------------------------------------------------------------- 
			else if (frm == 0x92)            	// IO-Data Sample
				{
				FRM0x92();
				}
// --- FRM 0x97 ---------------------------------------------------------------
			else if (frm == 0x97)            	// Remote Command Response
				{
				}
		
			else if (frm == 0xFF)            	// Prfsummenfehler
				{
				}

			else                             	// unbekanntes Frame-Format
				{
				}

			RX_ENABLE;									// nun knnen wieder neue Daten empfangen werden
		}	                                   	// if (FRM_is_received())

/*	if (xbee_flag & (1<<FRM_EXECUTE_CMD))			// es soll ein CMD ausgefhrt werden
		{
			xbee_flag &= (~(1<<FRM_EXECUTE_CMD));
//			if      (xbee_cmd_typ == AT_CMD)        FRM08_send_lokal_at_cmd(xbee_data, xbee_data_length);
//			else if (xbee_cmd_typ == REMOTE_AT_CMD) FRM17_send_remote_at_cmd(xbee_data, xbee_data_length, xbee_target_idx);
//			else if (xbee_cmd_typ == SEND_DATA)     FRM10_send_data(xbee_data, xbee_data_length, xbee_target_idx);
//			FRM10_send_data(xbee_data, xbee_data_length, xbee_target_idx, SEND_NO_RESPONSE);
		}
*/
	}                                     // while(1)
}

// --- [ eof ] ----------------------------------------------------------------
