// --- [ rs232_int.h ] ---------------------------------------------------------

#ifndef RS232_INT_
#define RS232_INT_

#define BAUD  	9600UL
//#define FCPU   3686400UL
#define TEILER ((F_CPU /(BAUD * 16UL)) -1)
//#define TEILER  23
#define TX_BUFFER_SIZE			128							// 2^x !!!
#define TX_BUFFER_MASK 			(TX_BUFFER_SIZE - 1)

// wenn die Handshake_Pins auf LOW gezogen sind, dann ist das Gert bereit
// wenn auf HIGH gezogen, dann drfen keine Daten versendet werden !
// RTS und CTS sind zwischen den Gerten berkreuz verbunden. CTS -> RTS 

#define HANDSHAKE_PORT			PORTD
#define HANDSHAKE_PIN			PIND
#define HANDSHAKE_DDR			DDRD
#define HANDSHAKE_RTS			PD6			// Input
#define HANDSHAKE_CTS			PD7			// Output

// CTS als Ausgang, RTS als Eingang mit Pullup
#define HANDSHAKE_INIT			(HANDSHAKE_DDR  |= (1 << HANDSHAKE_CTS)); \
										(HANDSHAKE_PORT |= (1 << HANDSHAKE_RTS))

#define RX_DISABLE				(HANDSHAKE_PORT |=  (1 << HANDSHAKE_CTS)) // auf High
#define RX_ENABLE				   (HANDSHAKE_PORT &= ~(1 << HANDSHAKE_CTS)) // auf Low

// while (TX_DISABLED); if (TX_ENABLED) ....
#define TX_DISABLED				(HANDSHAKE_PIN   & (1 << HANDSHAKE_RTS)	// if high
#define TX_ENABLED				(!(HANDSHAKE_PIN & (1 << HANDSHAKE_RTS))  // if low

// Register USCR0B konfigurieren
#define TX_ENABLE 	(1<<RXCIE0 | 1<<TXCIE0 | 0<<UDRIE0 | 1<<RXEN0 | 1<<TXEN0)
#define TX_DISABLE	(1<<RXCIE0 | 0<<TXCIE0 | 0<<UDRIE0 | 1<<RXEN0 | 1<<TXEN0)

void rs232_init(void);
void put_c(uint8_t Zeichen);
void put_s(char *s);
void puts_p(const char *progmem_s);

#endif
// --- [ eof ] ----------------------------------------------------------------
